/*****************************************************************************
 * contains include-files, constants, structure definitions and externals of 
 * history tracer
 *****************************************************************************/

/*#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <Xm/Xm.h>
#include <exBasics.h>
#include <exLayout.h>      in exMenuP.h included */

#include <exMenu.h>
#include <exEdit.h>
#include <exErrors.h>
#include "history.h"

#define H_BORDER        1                /* border size of father window */
#define H_TITLEBORDER   2                /* border size of title window */
#define H_NUMCOL        4                /* number of cols in number editor */
#define H_SCRLBWIDTH	20		 /* width of scrollbar */
#define HISTORY_OPEN    0x1              /* set if history editor is mapped */
#define XICON           1041             /* x-value for icon window */
#define YICON           140              /* y-value for icon window */
#define MAXHIST         100              /* maximum number of commands
					    stored in history tracer */
#define HISTMENUCNT     1                /* number of menus in history tracer */
#define HISTMENUS       "history.menu" 

#define LINEMARK        "  >"      /* marks continuation of command in tracer */
#define START           True
#define END             False

/*
 * structure to describe windows needed for the history editor
 */

typedef struct _historyWindow {
  Widget histShell;                    /* application shell */
  Widget histForm;                     /* form widget containing both
					  editors */
  exMenubar *menuBar;
  Widget scrollbar;
  Editor comEdit;                      /* Widget of command editor */
  Editor numEdit;                      /* Widget of number editor */
  int flag;
} historyWindow;

static EditorDescr HEditDescr = {
  (int (*)()) 0,                        /* input function */
  (char *) 0,                           /* file */
  (char *) 0,	                        /* editor name */
  (char **) 0,                          /* buffer */
  (Window) 0,                           /* message window */
  MAXHIST,    				/* number of lines in buffer */
  0,					/* lines in window */
  0,					/* cols  in window */
  0, 					/* width of window */
  0,					/* height of window */
  ED_HELP,                              /* flags */
};

static EditorDescr numDescr = {
  (int (*)()) 0,                        /* input function */
  (char *) 0,                           /* file */
  (char *) 0,	                        /* editor name */
  (char **) 0,                          /* buffer */
  (Window) 0,                           /* message window */
  MAXHIST,    				/* number of lines in buffer */
  0,					/* lines in window */
  H_NUMCOL,				/* cols  in window */
  0, 					/* width of window */
  0,					/* height of window */
  ED_HELP,                              /* flags */
};

typedef struct _commandStatistics {
  int comSeq[MAXHIST][2];
  int comCount;                /* holds number of commands in history tracer */
  char *complCom;
} commandStatistics;

BufInfo *bufinfoptr();

extern historyWindow *exHistory;
extern commandStatistics *comStat;




 




extern EditHistory(/* parent, x, y, l, c */);
extern addCommToHist(/* hw, clist, comm */);
extern adjustHistPtr(/* diff */);
extern char *nextCommand(/* htracer, socPtr */);
extern cntNewLines(/* buffer */);
extern compoundCom(/* clist, buffer */);
extern contHistory(/* parms */);
extern deleteComplCom(/* cs */);
extern deleteStatistics(/* cStat */);
extern exHistoryio(/* hwindow */);
extern execLastCom(/* editor */);
extern execNextCom(/* editor */);
extern execPrevCom(/* editor */);
extern execThisCom(/* editor */);
extern getComIndex(/* curLine, cs */);
extern hBbsearch(/* editor */);
extern hBdelword(/* editor */);
extern hBeglin(/* editor */);
extern hBotBuffer(/* editor */);
extern hBotscr(/* editor */);
extern hBwsearch(/* editor */);
extern hClearBuffer(/* editor */);
extern hCursorPos(/* w, event, params, num_params */);
extern hCut(/* editor */);
extern hDelnxt(/* editor */);
extern hDelprev(/* editor */);
extern hDwnScroll(/* editor */);
extern hDwncol(/* editor */);
extern hDwnpage(/* editor */);
extern hEditExit(/* editor */);
extern hEndlin(/* editor */);
extern hFdelword(/* editor */);
extern hFfsearch(/* editor */);
extern hFindFile(/* editor */);
extern hFsearch(/* editor */);
extern hGoLine(/* editor */);
extern hInsertFile(/* editor */);
extern hKillBuffer(/* editor */);
extern hKrest(/* editor */);
extern hLeft(/* editor */);
extern hLineToTop(/* editor */);
extern hMidscr(/* editor */);
extern hNewline(/* editor */);
extern hNewscr(/* editor */);
extern hOpenln(/* editor */);
extern hOpenlnd(/* editor */);
extern hRight(/* editor */);
extern hSaveFile(/* editor */);
extern hTopBuffer(/* editor */);
extern hTopscr(/* editor */);
extern hUpScroll(/* editor */);
extern hUpcol(/* editor */);
extern hUppage(/* editor */);
extern hWordl(/* editor */);
extern hWordr(/* editor */);
extern hWriteFile(/* editor */);
extern hYank(/* editor */);
extern insertCom(/* editor */);
extern joinWithNextCom(/* editor */);
extern quitHistory(/* parms */);
extern restoreHistory(/* parms */);
extern saveAsMacro(/* parms */);
extern saveHistory(/* parms */);
extern setHistPtr(/* editor */);
extern stopHistory(/* parms */);
extern updateStatistics(/* ht, cs, line, diff */);
extern void autodelHist(/* hw, cl, lines */);
extern void hCursorCopy(/* w, event, params, num_params */);
extern void hCursorCut(/* w, event, params, num_params */);
extern void hCursorDeselect(/* w, event, params, num_params */);
extern void hCursorPaste(/* w, event, params, num_params */);
extern void hCursorSelect(/* w, event, params, num_params */);
extern void saveComIndex(/* editor, cs, line, start */);
extern void setHistScrollbar(/* hwindow */);
